/* ---------------------------------------------------------- 
%   (C)1992 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
----------------------------------------------------------- */
/*----------------------------------------------------------------------

	ae_gltree.h
		genealogical tree

----------------------------------------------------------------------*/

#define	APS_X_GLTREE		100
#define	APS_Y_GLTREE		100

#define	APS_WIDTH_GLTREE	500
#define	APS_HEIGHT_GLTREE	400

#define	APS_MINWIDTH_GLTREE	APS_WIDTH_GLTREE
#define	APS_MINHEIGHT_GLTREE	APS_HEIGHT_GLTREE

#define	PB_WIDTH_GLTREE		70
#define	PB_HEIGHT_GLTREE	30

/*
#define	DA_WIDTH_GLTREE		APS_WIDTH_GLTREE
#define	DA_HEIGHT_GLTREE	(APS_HEIGHT_GLTREE - PB_HEIGHT_GLTREE)
*/

#define	MRGRATIO_X_GLTREE	0.05
#define	MRGRATIO_Y_GLTREE	0.05

#define	COLOR_SCALE_GLTREE	"yellow"
#define	COLOR_TREE_GLTRUPG	"green"
#define	COLOR_TREE_GLTRNJ	"red"

#define	LINEWIDTH_SCALE_GLTREE	1
#define	LINEWIDTH_TREE_GLTREE	3

#define	ADJFONT_PARAM_GLTREE_1	4
#define	ADJFONT_PARAM_GLTREE_2	2

#define	SCALE_DIVIDE_PARAM_GLTREE	5	/* >= 1 and <= 9 */

/*--------------------------------------------------------------------*/

#if	1

#include	"aedit.h"

#else

#define	MAX_ALIGN		128
#define	MAX_ALIGN_LENG	 	1500  
#define	MAX_ALIGN_NAME_LENG	12
#define	GAP_INNER_CODE		26
#define	OTHER_INNER_CODE	27

typedef struct {
   int   empty;                                       /* data is not exist */
   int   dataStartIndex;
   int   dispStartIndex;
   int   dataEndIndex;
   char  columnAtrib[MAX_ALIGN_LENG];                 /* column attribute */
   int   rowH;                                        /* pixel unit */
   int   columnCost[MAX_ALIGN_LENG];   
   int   columnCostMax;
   int   columnCostMin;
   int   cost;                                        /* alignment's  total cost */
   int   startPos[MAX_ALIGN], endPos[MAX_ALIGN];      /* Out gap start/end position */
   int   firstP[MAX_ALIGN][MAX_ALIGN];
   int   outGapP[MAX_ALIGN];
   int   alignnum;
   char  alignname[MAX_ALIGN][MAX_ALIGN_NAME_LENG+1]; /* alignment name */
   char  *codeAlign[MAX_ALIGN];                       /* inner code */
} INFO;

#endif

/*--------------------------------------------------------------------*/

/*  */

#define	GLTREE_ELM_NONE	0	/* ̤ */
#define	GLTREE_ELM_BTM	1	/* ǲ */
#define	GLTREE_ELM_BRCH	2	/* ʬ */

/* κǲ */

typedef	struct {
	float	posad;				/* 饤Ȱ
						   ʥ饤
						   */
	float	treemin;			/* posadƱ */
	float	treemax;			/* posadƱ */
	float	abdtv;				/* 饤Ȱ
						   ʵΥʷ
						   κǲˤ
						   еΥ */
	int	index;				/* ǥå */
	char	alname[MAX_ALIGN_NAME_LENG+1];	/* 饤̾ */
} GlTreeElmBtm;

/* ʬ*/

typedef	struct {
	float	posad;		/* ֡ʥ饤 */
	float	treemin;	/* ǰʲηΥ饤Ȱ
				   ʥ饤κǾ͡ */
	float	treemax;	/* ǰʲηΥ饤Ȱ
				   ʥ饤κ͡ */
	float	abdtv;		/* ʷκǲˤеΥ
				   ʵΥ*/
	float	rldtvleft;	/* ¦ηǤؤеΥ
				   ʵΥ*/
	float	rldtvright;	/* ¦ηǤؤеΥ
				   ʵΥ*/
	float	btmdtvleft;	/* ¦ηκǲǤޤǤεΥ
				   κ͡ʵΥ */
	float	btmdtvright;	/* ¦ηκǲǤޤǤεΥ
				   κ͡ʵΥ */
	float	rlrldtvavrg;	/* ºݤκηǤؤеΥ
				   ʿ */
	char	*left;		/* ¦η */
	char	*right;		/* ¦η */
} GlTreeElmOthr;

/* ǥǡ */

typedef	union {
	GlTreeElmBtm	btm;	/* ǲ */
	GlTreeElmOthr	brch;	/* ʬ */
} GlTreeElmData;

/*  */

typedef struct {
	int		dflag; /* ǡե饰
				  GLTREE_ELM_BTM, GLTREE_ELM_BRCH */
	GlTreeElmData	elmd;	/* ǥǡ */
} GlTreeElm;

/* Υơ֥롦ǥå */

typedef struct {
	int		index;		/* ǥå */
	GlTreeElm	*gltrelm;	/*  */
	float		idtv;		/* ǥåбΥ
					   ʣi ʣΣˡΤߡ */
} DtTbIndexElm;

/* Υơ֥ */

typedef struct {
	int	eflag;		/* ե饰
				   1:оݡ̤
				   0:ֹʽѤߡ͡ */
	int	row;		/*  */
	int	column;		/*  */
	float	distance;	/* Υ */
	float	rcdtv;		/* ԡбΥʣij
				   ʣΣˡΤߡ */
} DtTableElm;

/* ǡ */

typedef struct {
	int	areasize;	/* Υ */
	int	datasize;	/* ͭǡ */
	int	*idata;		/* ǡ */
} IDataAry;

/*--------------------------------------------------------------------*/

/* ؿΥޥ */

#define	MIN(a, b)	(((a) < (b)) ? (a) : (b))	/* Ǿ */
#define	MAX(a, b)	(((a) > (b)) ? (a) : (b))	/*  */

/*--------------------------------------------------------------------*/

/* å */

#if	1
#define	CHECK
#endif

/*----------------------------------------------------------------------
	eof
----------------------------------------------------------------------*/
