/* ---------------------------------------------------------- 
%   (C)1992 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
----------------------------------------------------------- */
/* color_menu.c 
 * treat options items commands.
 */

#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <X11/IntrinsicP.h>
#include <Xm/DialogS.h>
#include <Xm/Text.h>
#include <Xm/Label.h>
#include <Xm/LabelG.h>
#include <Xm/SeparatoG.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/BulletinB.h>
#include <Xm/Scale.h>
#include <Xm/Form.h>
#include <Xm/ToggleB.h>
#include <Xm/ToggleBG.h>
#include <Xm/MainW.h>
#include <Xm/DrawingA.h>
#include <Xm/CascadeBG.h>
#include <Xm/MessageB.h>
#include <Xm/FileSB.h>

#include "menu.h"
#include "aedit.h"

#define  TEXT_COLOR       1
#define  BACK_COLOR       2
#define  FIX_COLOR        3
#define  BOU_PLUS_COLOR   4
#define  BOU_MINUS_COLOR  5
#define  BOU_MOTIF_COLOR  6
#define  TOGGLE_NUM  28
#define  WHITE       0
#define  BLACK       1

typedef struct {
  char   *label;
  short  set;
  Widget toggle;
}  TOGGLE_INFO ;


static TOGGLE_INFO ToggleInfo[TOGGLE_NUM] =
{  {"A", 0},  {"B", 0}, {"C", 0},  {"D", 0}, {"E", 0},  {"F", 0}, 
   {"G", 0},  {"H", 0}, {"I", 0},  {"J", 0}, {"K", 0},  {"L", 0}, 
   {"M", 0},  {"N", 0}, {"O", 0},  {"P", 0}, {"Q", 0},  {"R", 0}, 
   {"S", 0},  {"T", 0}, {"U", 0},  {"V", 0}, {"W", 0},  {"X", 0}, 
   {"Y", 0},  {"Z", 0}, {"-", 0},  {" ", 0}
};


static  Pixel  Pixel0, Pixel1;

extern Widget  menu_top;

static Widget save_color_text;
static Widget scale_red, scale_green, scale_blue;
static Widget color_w, amino_color_w;
static  Widget text_black, text_white;
static XColor C0, C1;     /* the color in the color_w */
static int    Flag;   /* TEXT_COLOR, BACK_COLOR, FIX)COLOR */

void  cancelCB();

/* called when cancel button of file_selection_dialog is pushed */
void  cancel_fsd_colorCB(w,fsd,call_data)
Widget   w, fsd;
caddr_t  call_data;
{
  XtUnmanageChild(fsd); 
}



/* called when ok button of file_selection_dialog is pushed */
void  load_color_okCB(w,fsd,call_data)
Widget   w, fsd;
XmFileSelectionBoxCallbackStruct  *call_data;
{
  char *fname;
  FILE  *fp;
  int i;

  XmStringGetLtoR(call_data->value, XmSTRING_DEFAULT_CHARSET, &fname);
  fprintf(stderr, "fname=%s, strlen(fname)=%d, fname[0]=%d\n",fname,strlen(fname),fname[0]); 
  if(strlen(fname) == 0  ||  fname[0]==0)  
     popUpWarnDialog("You must specify a file name");
  else {
     fp = fopen(fname,"r");
     if(fp==NULL) 
        popUpWarnDialog("file %s fails to open for reading.",fname);
     else {
        readRcFile(fp);
        fclose(fp);     
        for(i=0; i<TOGGLE_NUM; ++i)  {
            XStoreColor(TheDisplay,TheColormap,&amino_color[i]);
        }
        disp(True);    /* display alignment, column#,identical column */
     }
  }
  XtFree(fname);
  XtUnmanageChild(fsd); 
}



/* called when open item of file menu is selected */
static void load_color(w,client_data,cbs)
Widget   w;
int     client_data;   /* not used */
XmAnyCallbackStruct *cbs;
{
  static Widget fsd=NULL;
  extern Widget  menu_top;
  Arg    args[10];

  if(!fsd) {
     fsd = XmCreateFileSelectionDialog(menu_top, "color_selection_dialog", args, 0);
     XtAddCallback(fsd, XmNcancelCallback, cancel_fsd_colorCB, fsd);
     XtAddCallback(fsd, XmNokCallback, load_color_okCB, fsd);
  }
  XtManageChild(fsd);
  XFlush(TheDisplay);
}



/* called when ok button of save color dialog is pushed */
void  save_color_okCB(w,dialog,call_data)
Widget   w, dialog;
caddr_t  call_data;
{
  char *fname;
  FILE *fp;
  void overwrite(), do_save_color();

  fname = XmTextGetString(save_color_text);
  fprintf(stderr, "fname=%s, strlen(fname)=%d, fname[0]=%d\n",fname,strlen(fname),fname[0]); 
  if(strlen(fname) == 0  ||  fname[0]==0)  
     popUpWarnDialog("You must specify a file name");
  else {
     fp = fopen(fname,"r");
     if(fp==NULL)  {  /* file not exist */
        fp = fopen(fname,"w");
        if(fp==NULL) {
           popUpWarnDialog("file %s can't open for writing.",fname);
           return;
        }
        do_save_color(fp); 
        fclose(fp);
     }
     else {  /* file already exist */
        fclose(fp);
        fp = fopen(fname,"w");
        if(fp==NULL) {
           popUpWarnDialog("file %s can't open for writing.",fname);
           return;
        }
        popUpConfirmDialog(overwrite,fp,False,"File already exist. Overwrite it?");
     }
  }
  XtFree(fname);
  XtPopdown(dialog); 
}



static void overwrite(w,fp,call_data)
Widget w;
FILE *fp;
XmAnyCallbackStruct  *call_data;
{
   void do_save_color();

   if(call_data->reason == XmCR_OK) {
      do_save_color(fp);
      fclose(fp);
   }
}



/* called when open item of "Save Color" menu is selected */
static void save_color(w,client_data,cbs)
Widget   w;
int     client_data;  /* not used */
XmAnyCallbackStruct *cbs;
{
  static Widget dialog=NULL;
  Widget bb,label,ok,cancel;
  Arg    args[10];
  XButtonEvent *ev;

  ev = (XButtonEvent *)cbs->event;
  if(!dialog) {
     XtSetArg(args[0],XmNx, ev->x_root-30);
     XtSetArg(args[1],XmNy, ev->y_root-30);
     XtSetArg(args[2],XmNautoUnmanage, False);
     dialog = XtCreatePopupShell("save_color_dialog",xmDialogShellWidgetClass,
                                 menu_top,args,3);

     XtSetArg(args[0],XmNautoUnmanage, False);
     bb=XmCreateBulletinBoard(dialog,"save_color_bb",args,1); 
     label=XmCreateLabel(bb,"save_color_label",NULL,0); XtManageChild(label);

     save_color_text=XmCreateText(bb,"save_color_text",NULL,0); 
     XtManageChild(save_color_text);

     ok=XmCreatePushButton(bb,"save_color_ok",NULL,0);  XtManageChild(ok);
     XtAddCallback(ok,XmNactivateCallback,save_color_okCB,dialog);
     cancel=XmCreatePushButton(bb,"save_color_cancel",NULL,0); XtManageChild(cancel);
     XtAddCallback(cancel,XmNactivateCallback,cancelCB,dialog);

     XtVaSetValues(bb, XmNdefaultButton,ok,NULL);
     XtManageChild(bb);
  }
  XtVaSetValues(dialog,XmNx,ev->x_root,XmNy,ev->y_root,NULL);
  XtPopup(dialog,XtGrabNone); 
}


color_scaleCB(scale,rgb,cbs)
Widget  scale;
int     rgb;      
XmScaleCallbackStruct *cbs;
{
  switch(rgb) {
  case DoRed:
       C0.red = cbs->value;
       break;
  case DoGreen:
       C0.green = cbs->value;
       break;
  case DoBlue:
       C0.blue = cbs->value;
       break;
  }
  C0.flags = DoRed|DoGreen|DoBlue;
  C0.pixel = Pixel0;
  XStoreColor(TheDisplay,TheColormap,&C0);
  XFlush(TheDisplay);
  XtVaSetValues(color_w,XmNbackground,C0.pixel,NULL);
}



static void change_color_okCB(scale,client_data,cbs)
Widget  scale;
caddr_t client_data;    /* not used */
XmScaleCallbackStruct *cbs;
{
  switch(Flag) {
  case BACK_COLOR:
       back_color.red = C0.red;
       back_color.green = C0.green;
       back_color.blue = C0.blue;
       XStoreColor(TheDisplay,TheColormap,&back_color);
       break;
  case TEXT_COLOR:
       text_color.red = C0.red;
       text_color.green = C0.green;
       text_color.blue = C0.blue;
       XStoreColor(TheDisplay,TheColormap,&text_color);
       break;
  case FIX_COLOR:
       fixed_column_color.red = C0.red;
       fixed_column_color.green = C0.green;
       fixed_column_color.blue = C0.blue;
       XStoreColor(TheDisplay,TheColormap,&fixed_column_color);
       break;
  case BOU_PLUS_COLOR:
       bou_plus_color.red = C0.red;
       bou_plus_color.green = C0.green;
       bou_plus_color.blue = C0.blue;
       XStoreColor(TheDisplay,TheColormap,&bou_plus_color);
       break;
  case BOU_MINUS_COLOR:
       bou_minus_color.red = C0.red;
       bou_minus_color.green = C0.green;
       bou_minus_color.blue = C0.blue;
       XStoreColor(TheDisplay,TheColormap,&bou_minus_color);
       break;
  case BOU_MOTIF_COLOR:
       bou_motif_color.red = C0.red;
       bou_motif_color.green = C0.green;
       bou_motif_color.blue = C0.blue;
       XStoreColor(TheDisplay,TheColormap,&bou_motif_color);
       break;
  }
  disp(True);   /* display alignment, column#,identical column */
}



/* called when "Background", "Text" menu is selected */
static void change_color(w,flag,cbs)
Widget   w;
int      flag;  /* BACK or TEXT or FIX */
XmAnyCallbackStruct *cbs;
{
  int  i, x, y, result, dummy;
  static Widget dialog=NULL;
  static Widget scale_red, scale_green, scale_blue;
  Widget rc,rc1,rc2,ok,cancel;
  Arg    args[10];
  XButtonEvent *ev;

  Flag = flag;  

  ev = (XButtonEvent *)cbs->event;
  if(!dialog) {
     XtSetArg(args[0],XmNallowShellResize,True);
     dialog = XtCreatePopupShell("change_color_dialog",transientShellWidgetClass,
                                  menu_top,args,1);

     rc=XmCreateRowColumn(dialog,"change_color_rc",NULL,0);  XtManageChild(rc);

     result = XAllocColorCells(TheDisplay,TheColormap,False,
                                NULL,0,&Pixel0,1);
     if(result==0) {
        puts("Can't Alloc Color Cell");
        dialog=NULL;
        return;
     }
     C0.pixel = Pixel0;
     C0.flags = DoRed|DoGreen|DoBlue;
     color_w = XtVaCreateManagedWidget("color_w",
                   widgetClass,rc,   /* Core widget */
                   XmNwidth,   120,
                   XmNheight,  100,
                   NULL);

     rc1 = XtVaCreateManagedWidget("change_color_rc1",
              xmRowColumnWidgetClass,rc,
              XmNorientation, XmHORIZONTAL,
              NULL);

     make_rgb_scales(rc1,color_scaleCB,
            &scale_red, &scale_green, &scale_blue);

     rc2 = XtVaCreateManagedWidget("change_color_rc2",
              xmRowColumnWidgetClass,rc,
              XmNorientation, XmHORIZONTAL,
              NULL);

     ok=XmCreatePushButton(rc2,"      Change      ",NULL,0);  XtManageChild(ok);
     XtAddCallback(ok,XmNactivateCallback,change_color_okCB,NULL);
     cancel=XmCreatePushButton(rc2,"      Cancel      ",NULL,0); XtManageChild(cancel);
     XtAddCallback(cancel,XmNactivateCallback,cancelCB,dialog);
  }

  /* initial color of color_w */
  switch(Flag) {
     case BACK_COLOR:
        C0 = back_color;
        break;
     case TEXT_COLOR:
        C0 = text_color;
        break;
     case FIX_COLOR:
        C0 = fixed_column_color;
        break;
     case BOU_PLUS_COLOR:
        C0 = bou_plus_color;
        break;
     case BOU_MINUS_COLOR:
        C0 = bou_minus_color;
        break;
     case BOU_MOTIF_COLOR:
        C0 = bou_motif_color;
        break;
  }
  XtVaSetValues(scale_red,  XmNvalue, C0.red,  NULL);
  XtVaSetValues(scale_green,XmNvalue, C0.green,NULL);
  XtVaSetValues(scale_blue, XmNvalue, C0.blue, NULL);
  C0.pixel = Pixel0;
  C0.flags = DoRed|DoGreen|DoBlue;
  XStoreColor(TheDisplay,TheColormap,&C0);
  XtVaSetValues(color_w,XmNbackground,C0.pixel,NULL);
  XtVaSetValues(dialog,XmNx,ev->x_root,XmNy,ev->y_root,NULL);
  XtPopup(dialog,XtGrabNone); 
}



/* called when "Amino Color Scale" is moved */
amino_color_scaleCB(scale,rgb,cbs)
Widget  scale;
int     rgb;      
XmScaleCallbackStruct *cbs;
{
   static int first=True;
   int    result;

   switch(rgb) {
   case DoRed:
        C1.red = cbs->value;
        break;
   case DoGreen:
        C1.green = cbs->value;
        break;
   case DoBlue:
        C1.blue = cbs->value;
        break;
   }
   C1.flags = DoRed|DoGreen|DoBlue;
   C1.pixel = Pixel1;
   XStoreColor(TheDisplay,TheColormap,&C1);
   XFlush(TheDisplay);
   XtVaSetValues(amino_color_w,XmNbackground,C1.pixel,NULL);
}



amino_color_okCB(scale,dialog,cbs)
Widget  scale;
Widget  dialog;
XmScaleCallbackStruct *cbs;
{
  int i;

  for(i=0; i<TOGGLE_NUM; ++i)  {
      if(ToggleInfo[i].set) {
         amino_color[i].red = C1.red;
         amino_color[i].green = C1.green;
         amino_color[i].blue = C1.blue;
         XStoreColor(TheDisplay,TheColormap,&amino_color[i]);
      }
  }
  disp(True);
}


clear_toggleCB(button,client_data,cbs)
Widget  button;
caddr_t client_data;    /* not used */
XmAnyCallbackStruct *cbs;
{
  int i;

  for(i=0; i<TOGGLE_NUM; ++i) {
     ToggleInfo[i].set = False;
     XtVaSetValues(ToggleInfo[i].toggle, XmNset, False, NULL);
  }
}


/* called when text color toggle button pushed */
text_color_toggleCB(toggle,flag,cbs)
Widget  toggle;
int     flag;     /* BLACK or WHITE */
XmToggleButtonCallbackStruct  *cbs;
{
  int i, black;
  GC  gc;

  if(flag==WHITE){
     XtVaSetValues(text_black, XmNset, True,  NULL);
     XtVaSetValues(text_white, XmNset, False, NULL);
     gc = WhiteGC;
  }
  else {
     XtVaSetValues(text_black, XmNset, False,  NULL);
     XtVaSetValues(text_white, XmNset, True,   NULL);
     gc = BlackGC;
  }

  for(i=0; i<TOGGLE_NUM; ++i)  {
      if(ToggleInfo[i].set) {
          aminoCharWorB[i] = (short)flag;
          AminoCharGC[i] = gc;
      }
  }
  /*disp(True);*/
}



/* called when "Amino Back" menu is selected */
static void amino_back(w,flag,cbs)
Widget   w;
int      flag;  /* BACK or TEXT or FIX */
XmAnyCallbackStruct *cbs;
{
  int i,x,y,result;
  static Widget dialog=NULL;
  Widget fm, rc1,rc2,rc3, rc11,rc12, rc13, rc31, rc32, rc33,
         ok,cancel, button;
  Arg    args[10];
  XButtonEvent *ev;

  Flag = flag;  

  ev = (XButtonEvent *)cbs->event;
  if(!dialog) {
     XtSetArg(args[0],XmNallowShellResize,False);
     dialog = XtCreatePopupShell("amino_back_dialog",transientShellWidgetClass,
                                 menu_top,args,1);

     fm = XtVaCreateManagedWidget("amino_back_fm",
              xmFormWidgetClass,dialog, 
              XmNwidth, 470,  XmNheight, 280,
              NULL);

     rc1 = XtVaCreateManagedWidget("amino_back_rc1",
              xmRowColumnWidgetClass,fm,
              XmNorientation, XmHORIZONTAL,
              NULL);

     rc2 = XtVaCreateManagedWidget("amino_back_rc2",
              xmRowColumnWidgetClass, fm, 
              NULL);

     rc3 = XtVaCreateManagedWidget("amino_back_rc3",
              xmRowColumnWidgetClass, fm, 
              NULL);

     /*-------------------  children of rc1 ---------------------*/
     rc11 = XtVaCreateManagedWidget("amino_back_rc11",
              xmRowColumnWidgetClass,rc1,
              XmNorientation, XmVERTICAL,
              NULL);

     rc12 = XtVaCreateManagedWidget("amino_back_rc12",
              xmRowColumnWidgetClass,rc1,
              XmNorientation, XmVERTICAL,
              NULL);

     rc13 = XtVaCreateManagedWidget("amino_back_rc13",
              xmRowColumnWidgetClass,rc1,
              XmNorientation, XmVERTICAL,
              NULL);

     make_toggle(rc11,0,9);
     make_toggle(rc12,10,19);
     make_toggle(rc13,20,27);

     /*-------------------  children of rc2 ---------------------
     button = XtVaCreateManagedWidget("clear_button",
              xmPushButtonWidgetClass,rc2,
              XmNwidth,  40,
              NULL);
     XtAddCallback(button,XmNactivateCallback,clear_toggleCB,NULL);*/

     /*-------------------  children of rc3 ---------------------*/
     result = XAllocColorCells(TheDisplay,TheColormap,False,
                                NULL,0,&Pixel1,1);
     if(result==0) {
        puts("Can't Alloc Color Cell");
        dialog=NULL;
        return;
     }
     C1.pixel = Pixel1;
     C1.red = C1.green = C1.blue = 0;
     XStoreColor(TheDisplay,TheColormap,&C1);
     amino_color_w = XtVaCreateManagedWidget("amino_color_w",
                       widgetClass,rc3,   /* Core widget */
                       XmNwidth,   180,
                       XmNheight,  80,
                       XmNbackground, Pixel1,
                       NULL);

     rc31 = XtVaCreateManagedWidget("rc_for_scales",
              xmRowColumnWidgetClass,rc3,
              XmNorientation, XmHORIZONTAL,
              XmNheight,  130,
              NULL);
     make_rgb_scales(rc31,amino_color_scaleCB,
            &scale_red, &scale_green, &scale_blue);

     rc32 = XtVaCreateManagedWidget("amino_color_rc32",
              xmRowColumnWidgetClass,rc3,
              XmNorientation, XmHORIZONTAL,
              NULL);
     /*-------------------  children of rc32 ---------------------*/
     ok=XmCreatePushButton(rc32,"amino_color_ok",NULL,0);  XtManageChild(ok);
     XtAddCallback(ok,XmNactivateCallback,amino_color_okCB,dialog);
     cancel=XmCreatePushButton(rc32,"amino_color_cancel",NULL,0); XtManageChild(cancel);
     XtAddCallback(cancel,XmNactivateCallback,cancelCB,dialog);

     rc33 = XtVaCreateManagedWidget("amino_color_rc33",
              xmRowColumnWidgetClass,rc3,
              XmNorientation, XmHORIZONTAL,
              NULL);
    
     /*-------------------  children of rc33 ---------------------*/
     text_black = XtVaCreateManagedWidget("Text Black",
              xmToggleButtonGadgetClass,rc33,
              XmNindicatorType, XmONE_OF_MANY,
              NULL);
     text_white = XtVaCreateManagedWidget("Text White",
              xmToggleButtonGadgetClass,rc33,
              XmNindicatorType, XmONE_OF_MANY,
              NULL);
     XtAddCallback(text_black,XmNvalueChangedCallback,
                   text_color_toggleCB,BLACK);
     XtAddCallback(text_white,XmNvalueChangedCallback,
                   text_color_toggleCB,WHITE);

  }
  XtVaSetValues(text_black, XmNset, True,  NULL);
  XtVaSetValues(text_white, XmNset, False, NULL);
  XtVaSetValues(scale_red,  XmNvalue, 0,NULL);
  XtVaSetValues(scale_green,XmNvalue, 0,NULL);
  XtVaSetValues(scale_blue, XmNvalue, 0,NULL);
  C1.red=C1.green=C1.blue=0;
  C1.pixel = Pixel1;
  C1.flags = DoRed|DoGreen|DoBlue;
  XStoreColor(TheDisplay,TheColormap,&C1);
  XtVaSetValues(amino_color_w,XmNbackground,Pixel1,NULL);
  XtVaSetValues(dialog,XmNx,ev->x_root,XmNy,ev->y_root,NULL);
  XtPopup(dialog,XtGrabNone); 
}


/* called ToggleButton is selected */
static void toggleCB(w,index,cbs)
Widget  w;
int     index;
XmToggleButtonCallbackStruct  *cbs;
{
    int i;
    Arg args[1];
    static int old_index = 0;

    ToggleInfo[old_index].set = False;
    XtVaSetValues(ToggleInfo[old_index].toggle, XmNset, False, NULL);
    ToggleInfo[index].set = cbs->set;
    XtVaSetValues(ToggleInfo[index].toggle, XmNset, True, NULL);

    if (aminoCharWorB[index] == 0){
        XtVaSetValues(text_black, XmNset, True,  NULL);
        XtVaSetValues(text_white, XmNset, False, NULL);
    }else{
        XtVaSetValues(text_black, XmNset, False,  NULL);
        XtVaSetValues(text_white, XmNset, True,   NULL);
    }

    XtSetArg(args[0], XmNvalue, amino_color[index].red);
    XtSetValues(scale_red, args, 1);
    XtSetArg(args[0], XmNvalue, amino_color[index].green);
    XtSetValues(scale_green, args, 1);
    XtSetArg(args[0], XmNvalue, amino_color[index].blue);
    XtSetValues(scale_blue, args, 1);
    C1.red = amino_color[index].red;
    C1.green = amino_color[index].green;
    C1.blue = amino_color[index].blue;
    C1.flags = DoRed|DoGreen|DoBlue;
    C1.pixel = Pixel1;
    XStoreColor(TheDisplay,TheColormap,&C1);
    XFlush(TheDisplay);
    XtVaSetValues(amino_color_w,XmNbackground,C1.pixel,NULL);

    old_index = index;
}



static make_toggle(parent,start,end)
Widget parent;
int    start,end;   /* start,end index */
{
   Widget  w;
   int     i;

   for(i=start; i<=end; ++i) {
      w = XtVaCreateManagedWidget(ToggleInfo[i].label,
              xmToggleButtonGadgetClass,parent,NULL);
      XtAddCallback(w,XmNvalueChangedCallback,toggleCB,i);
      ToggleInfo[i].toggle = w;
   }
}
      
static make_rgb_scales(parent,scaleCB,rs,gs,bs)
Widget parent;
void   (*scaleCB)();
Widget *rs, *gs,*bs;
{
   int i,x,y;
   Arg    args[10];
   XmString  xms;

   /* Red Scroll bar */

   xms = XmStringCreateLtoR("Red",
                           XmSTRING_DEFAULT_CHARSET);
   XtSetArg(args[0], XmNtitleString, xms);
   XtSetArg(args[1], XmNmaximum,   65535);
   XtSetArg(args[2], XmNshowValue, True);
   *rs = XtCreateManagedWidget("red",xmScaleWidgetClass, parent,
                                    args,3);
   XtAddCallback(*rs,XmNdragCallback,scaleCB,DoRed);
   XtAddCallback(*rs,XmNvalueChangedCallback,scaleCB,DoRed);
   XmStringFree(xms);

   /* Green Scroll bar */
   xms = XmStringCreateLtoR("Green",
                               XmSTRING_DEFAULT_CHARSET);
   XtSetArg(args[0], XmNtitleString, xms);
   *gs = XtCreateManagedWidget("green",xmScaleWidgetClass, parent,
                                  args,3);     
   XtAddCallback(*gs,XmNdragCallback,scaleCB,DoGreen);
   XtAddCallback(*gs,XmNvalueChangedCallback,scaleCB,DoGreen);
   XmStringFree(xms);

   /* Blue Scroll bar */
   xms = XmStringCreateLtoR("Blue",
                             XmSTRING_DEFAULT_CHARSET);
   XtSetArg(args[0], XmNtitleString, xms);
   *bs = XtCreateManagedWidget("blue",xmScaleWidgetClass, parent,
                                       args,3);
   XtAddCallback(*bs,XmNdragCallback,scaleCB,DoBlue);
   XtAddCallback(*bs,XmNvalueChangedCallback,scaleCB,DoBlue);
   XmStringFree(xms);
}


MENUITEM color_menu[] = {
   { "Load Color...", &xmPushButtonGadgetClass, 'L', NULL, NULL,
      load_color, (caddr_t)NULL, NULL, True},
   { "Save Color...", &xmPushButtonGadgetClass, 'O', NULL, NULL,
      save_color, (caddr_t)NULL, NULL, True},
   { "", &xmSeparatorGadgetClass, NULL, NULL, NULL,
      NULL, (caddr_t)NULL, NULL, True},
   { "Amino ...", &xmPushButtonGadgetClass, 'A', NULL, NULL,
      amino_back, (caddr_t)NULL, NULL, True},
   { "", &xmSeparatorGadgetClass, NULL, NULL, NULL,
      NULL, (caddr_t)NULL, NULL, True},
   { "Background...", &xmPushButtonGadgetClass, 'B', NULL, NULL,
      change_color, (caddr_t)BACK_COLOR, NULL, True},
   { "Text...",  &xmPushButtonGadgetClass, 'T', NULL, NULL,
      change_color, (caddr_t)TEXT_COLOR, NULL, True},
   { "Fix Column...",  &xmPushButtonGadgetClass, 'T', NULL, NULL,
      change_color, (caddr_t)FIX_COLOR, NULL, True},
   { "Bar Chart Plus...",  &xmPushButtonGadgetClass, 'P', NULL, NULL,
      change_color, (caddr_t)BOU_PLUS_COLOR, NULL, True},
   { "Bar Chart Minus...",  &xmPushButtonGadgetClass, 'M', NULL, NULL,
      change_color, (caddr_t)BOU_MINUS_COLOR, NULL, True},
   { "Bar Chart Motif...",  &xmPushButtonGadgetClass, 'M', NULL, NULL,
      change_color, (caddr_t)BOU_MOTIF_COLOR, NULL, True},
   {NULL},
};



void do_save_color(fp)
FILE *fp;
{
   int  i;

   fprintf(fp,"background-color    %5d  %5d  %5d\n",
           back_color.red, back_color.green, back_color.blue);
   fprintf(fp,"fixed-column-color  %5d  %5d  %5d\n",
           fixed_column_color.red, fixed_column_color.green, 
           fixed_column_color.blue);
   fprintf(fp,"text-color          %5d  %5d  %5d\n",
           text_color.red, text_color.green, text_color.blue);
   fprintf(fp,"bar-chart-plus-color    %5d  %5d  %05d\n",
           bou_plus_color.red, bou_plus_color.green, bou_plus_color.blue);
   fprintf(fp,"bar-chart-minus-color   %5d  %5d  %5d\n",
           bou_minus_color.red, bou_minus_color.green, bou_minus_color.blue);
   fprintf(fp,"bar-chart-motif-color   %5d  %5d  %5d\n",
           bou_motif_color.red, bou_motif_color.green, bou_motif_color.blue);

   for(i=0; i<26; ++i) {
       fprintf(fp,"amino-%c-color   %5d  %5d  %5d  %1d\n", 
               i+'a', amino_color[i].red, amino_color[i].green, amino_color[i].blue,
               (int)aminoCharWorB[i]);
   }

   fprintf(fp,"gap-color       %5d  %5d  %5d  %1d\n", 
           amino_color[26].red, amino_color[26].green, amino_color[26].blue,
           (int)aminoCharWorB[i]);
}


#undef  TEXT_COLOR
#undef  BACK_COLOR
#undef  FIX_COLOR
#undef  BOU_PLUS_COLOR
#undef  BOU_MINUS_COLOR
#undef  BOU_MOTIF_COLOR
#undef  TOGGLE_NUM 
#undef  WHITE      
#undef  BLACK      


