/* ---------------------------------------------------------- 
%   (C)1992 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
----------------------------------------------------------- */
/* ------------------------------------------------------- */
/*       checkGap.c                                        */
/*           check "gap columns"                           */
/*              gap column = percentage of gaps >= Percent */ 
/* ------------------------------------------------------- */

#include   <stdio.h>
#include   <string.h>
#include   <ctype.h>
#include "ste.h"
#include "stem_s.h"
/*
#define DEBUG TRUE 
*/

/* make table for display columns  */

void  make_consensus_for_hyoji(select_flag)
     int  select_flag;
  /* select_flag = TRUE -> SELECT */
  /* select_flag = FALSE -> ORIGINAL */
{
  int i,gapColumnCount,hyoujiColumnCount;

  gapColumnCount = 0;  /* no. of gap columns */
  hyoujiColumnCount = 0; /* no. of displayed columns */

  if(!select_flag)
    { /* ORIGINAL */
      for(i=0;i!=NoOfColumn;i++)
	{
	  if(consensus[i][1] >= Percent && consensus[i][0] == GAP)
	    { /* this column is gap column */
	      gapColumnCount++;
	      original_hyouji_table[i] = GAP_COLUMN;
	    }
	  else if(consensus[i][1] >= Percent)
	    { 
	      original_hyouji_table[i] = hyoujiColumnCount;
	      consensus_for_hyouji[hyoujiColumnCount] = consensus[i][0];
	      hyoujiColumnCount++;
	    }
	  else
	    {
	      original_hyouji_table[i] = hyoujiColumnCount;
	      consensus_for_hyouji[hyoujiColumnCount] = OTHER;
	      hyoujiColumnCount++;
	    }
	}
      
      NoOfHyoujiColumn = NoOfColumn - gapColumnCount;
      
    }


  if(select_flag)
    { /* SELECT */
      for(i=0;i!=NoOfColumn;i++)
	{
	  if(consensusSelected[i][1] >= Percent_s && consensusSelected[i][0] == GAP)
	    { /* this column is gap column */
	      gapColumnCount++;
	      original_hyouji_tableS[i] = GAP_COLUMN;
	    }
	  else if(consensusSelected[i][1] >= Percent_s)
	    { 
	      original_hyouji_tableS[i] = hyoujiColumnCount;
	      consensus_for_hyoujiS[hyoujiColumnCount] = consensusSelected[i][0];
	      hyoujiColumnCount++;
	    }
	  else
	    {
	      original_hyouji_tableS[i] = hyoujiColumnCount;
	      consensus_for_hyoujiS[hyoujiColumnCount] = OTHER;
	      hyoujiColumnCount++;
	    }
	}
      
      NoOfHyoujiColumnS = NoOfColumn - gapColumnCount;
      
    }


#ifdef DEBUG
  printf("\n ==== checkGap.c =====\n");
  printf("   NoOfColumn = %d\n",NoOfColumn);
  printf("   original_hyouji_table = \n");
  for(i=0;i!=NoOfColumn;i++)
    printf("%3d ",original_hyouji_table[i]);
  printf("\n   consensus_for_hyouji = \n    \n");
  for(i=0;i!=hyoujiColumnCount;i++)
    printf("%3d ",consensus_for_hyouji[i]);
  printf("\n\n  NoOfHyoujiColumn = %3d , gapColumnCount = %3d\n",
	          NoOfHyoujiColumn,gapColumnCount);

#endif

}

/* --------------- end of checkGap.c --------------------------- */
